# $Id: utils.spec,v 1.22 2008-09-29 16:53:59 ricardo.maraschini Exp $
# Authority: OpServices

%define _rootdir /usr/local/opmon

%{?dist: %{expand: %%define %dist 1}}

%{?rh7:%define _without_embedperl 1}
%{?rh7:%define _without_perlcache 1}
%{?el2:%define _without_embedperl 1}
%{?el2:%define _without_perlcache 1}

### FIXME: TODO: Add sysv script based on template. (remove cmd-file on start-up)
%define logmsg logger -t %{name}/rpm

Summary: OpMon utilities
Name: opmon-utils
Version: %{_op_major_version}.%{_op_minor_version}
Release: %{_op_release}
License: GPL
Group: Applications/System
URL: http://www.opservices.com.br
AutoReq: 0

Packager: OpServices <info@opservices.com.br>
Vendor: OpServices, http://www.opservices.com.br

Source: http://www.opservices.com.br/downloads/%{name}-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

%if 0%{?rhel} == 6
Requires: opmon-rsched >= %{_op_major_version}, opmon-scatsubscriber >= %{_op_major_version}, sudo, rsync, sysstat, perl, libtpl, net-snmp, net-snmp-utils, net-snmp-libs, samba < 4
%endif

%if 0%{?rhel} == 5
Requires: opmon-rsched >= %{_op_major_version}, opmon-scatsubscriber >= %{_op_major_version}, sudo, rsync, sysstat, perl, libtpl, net-snmp, net-snmp-utils, net-snmp-libs, samba < 4
%endif

Provides: opmon-utils
Obsoletes: opservices-utils

%description
OpMon utils

%prep
%setup -q

%build
# the compilation
cd scripts
%{__make} all

%install
%{__rm} -rf %{buildroot}
%{__mkdir} -p %{buildroot}%{_rootdir}/utils
%{__mkdir} -p %{buildroot}/etc/cron.d
%{__mkdir} -p %{buildroot}/etc/rc.d
%{__mkdir} -p %{buildroot}/etc/samba
%{__mkdir} -p %{buildroot}/etc/syncfiles.d
%{__mkdir} -p %{buildroot}/etc/init.d
%{__mkdir} -p %{buildroot}/etc/logrotate.d/
%{__mkdir} -p %{buildroot}/usr/local/opmon/libexec/opservices
%{__mkdir} -p %{buildroot}/etc/ha.d/
%{__mkdir} -p %{buildroot}/usr/share/snmp/mibs
%{__mkdir} -p %{buildroot}/usr/include/
%{__mkdir} -p %{buildroot}/usr/lib/
%{__mkdir} -p %{buildroot}/usr/bin/
%{__cp} -frp syncfiles.d/* %{buildroot}/etc/syncfiles.d/
%{__cp} -frp syncfiles.conf %{buildroot}/etc/syncfiles.conf
%{__cp} -frp syncfiles.logrotate %{buildroot}/etc/logrotate.d/syncfiles
%{__cp} -frp syncfiles %{buildroot}/etc/init.d
%{__cp} -frp opdiscovery-init %{buildroot}/etc/init.d/opdiscovery
%{__cp} -frp * %{buildroot}%{_rootdir}/utils
%{__cp} -frp backup.cron %{buildroot}/etc/cron.d/backup
%{__cp} -frp RFC1628cs121.MIB %{buildroot}/usr/share/snmp/mibs/RFC1628cs121.MIB
%{__cp} -frp check_statuslog.cron %{buildroot}/etc/cron.d/check_statuslog
%{__cp} -frp clean-incrementals.cron %{buildroot}/etc/cron.d/clean-incrementals
%{__cp} -frp clean-opmon-temp.cron %{buildroot}/etc/cron.d/clean-opmon-temp
%{__cp} -frp smb.conf %{buildroot}/etc/samba/smb.conf-opmon
%{__cp} -frp rc.firewall %{buildroot}/etc/rc.d/
%{__cp} -frp cluster/ha.d/* %{buildroot}/etc/ha.d/
%{__cp} -frp scripts/opservices.h %{buildroot}/usr/include/
%{__cp} -frp scripts/libopservices.so %{buildroot}/usr/lib/
%{__mv} import_opmon_delayed_messages %{buildroot}/usr/bin/

# OpMon discovery plugins
rm -rf scripts/*.c
rm -rf scripts/*.cpp
rm -rf scripts/*.h
rm -rf scripts/Makefile
%{__cp} -frp scripts/* %{buildroot}/usr/local/opmon/libexec/opservices


%pre

%post
if [ `/bin/cat /etc/sudoers | grep "NOPASSWD: /etc/rc.d/init.d/httpd" | wc -l` -eq 0 ]; then
	/usr/bin/printf %b "apache\tALL=(ALL)\tNOPASSWD: /etc/rc.d/init.d/httpd\n" >> /etc/sudoers
fi

/usr/bin/php /usr/local/opmon/utils/edit_sudoers.php >/tmp/edit_sudoers.log 2>&1
/bin/mv /etc/samba/smb.conf /etc/samba/smb.conf-centos
/bin/mv /etc/samba/smb.conf-opmon /etc/samba/smb.conf
/usr/bin/php /usr/local/opmon/utils/migrate-contact-alias.php >/tmp/migrate-contact-alias.log 2>&1
/usr/bin/php /usr/local/opmon/utils/migrate-favorite-and-shortcut-links.php >/tmp/migrate-favorite-and-shortcut-links.log 2>&1
/usr/local/opmon/utils/adjust-cron-op45.pl >/tmp/adjust-cron-op45.log 2>&1
# Adjust mysql conf add new tmpdir
/usr/local/opmon/utils/adjust-mysql-conf.pl > /dev/null 2>&1

# migration scripts to 4.5 version
/etc/init.d/gearman-utils stop >>/tmp/migrate-scat-contact-data.log 2>&1
/etc/init.d/gearman-utils start >>/tmp/migrate-scat-contact-data.log 2>&1

/usr/bin/php /usr/local/opmon/utils/opmon44-45/migrate-contacts-submenus.php >>/tmp/migrate-contacts-submenus.log 2>&1
/usr/bin/php /usr/local/opmon/utils/opmon44-45/migrate-scat-contact-data.php >>/tmp/migrate-scat-contact-data.log 2>&1
/usr/bin/php /usr/local/opmon/utils/opmon44-45/update-scheduled-contacts.php >>/tmp/update-scheduled-contacts.log 2>&1

/usr/bin/php /usr/local/opmon/utils/reset_shortcut_order.php

if [ -d "/usr/lib64/" ]; then
	ln -s /usr/lib/libopservices.so /usr/lib64/libopservices.so 2>&-
fi
# if OpMon in cluster, remove it from boot
# heartbeat shall manage it
FILE="/usr/local/opmon/etc/jobservers";
LINE=0
if [ -f $FILE ];
then
        LINE=`/bin/cat $FILE | /usr/bin/wc -l`
fi
if [ $LINE -gt 1 ];
then
        # Cluster mode - remove from boot
        /sbin/chkconfig --del opdiscovery >/dev/null 2>&1
else
        # single node - add to boot
        /sbin/chkconfig opdiscovery on >/dev/null 2>&1
        /sbin/service opdiscovery stop >/dev/null 2>&1
        /sbin/service opdiscovery start >/dev/null 2>&1
fi

# Configuring SNMP to allow access to all IDS
SNMPD="/etc/snmp/snmpd.conf"
if ! /bin/grep -q '^view    systemview    included   .1$' $SNMPD; then
	/bin/sed -i 's/^view/#view/g; /.1.3.6.1.2.1.1/ i view    systemview    included   .1' $SNMPD
fi

/sbin/chkconfig --level 2345 snmpd on >/dev/null 2>&1

%preun

%postun
/usr/local/opmon/utils/flush_memcache.php >/dev/null 2>&1 || :

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(0775, opuser, apache, 0775)
/usr/local/opmon/utils/
%config(noreplace) /usr/local/opmon/utils/clean-incrementals.pl
%config(noreplace) /etc/rc.d/rc.firewall
%config(noreplace) /etc/syncfiles.conf
/etc/init.d/syncfiles
%config(noreplace) /etc/syncfiles.d/
/etc/logrotate.d/syncfiles
/etc/init.d/opdiscovery
/usr/local/opmon/libexec/opservices/
/usr/include/opservices.h
/usr/lib/libopservices.so
/usr/bin/import_opmon_delayed_messages

%defattr(0600, root, root, 0755)
%config(noreplace) /etc/ha.d/authkeys

%defattr(0644, root, root, 0755)
%config(noreplace) /etc/ha.d/ha.cf
%config(noreplace) /etc/cron.d/backup
%config(noreplace) /etc/cron.d/check_statuslog
%config(noreplace) /etc/cron.d/clean-incrementals
%config(noreplace) /etc/cron.d/clean-opmon-temp
/etc/samba/

%defattr(0644, root, root)
/usr/share/snmp/mibs/RFC1628cs121.MIB

%changelog

